package alternatore.split;

import alternatore.drivers.driverIn.DriverIn;
import alternatore.drivers.driverIn.IPipeIn;
import alternatore.drivers.driverOut.DriverOut;
import alternatore.drivers.driverOut.IPipeOut;

import util.ParmsDB;

public class Build {

    private static Logica logica;
    
    private static ParmsDB db; 
    
    public static void main(String [] args) {
        ParmsDB db = new ParmsDB(args);   /** -pp ... -lca ... -lcp ... -uca ... -ucp ... */
        build();
        logica.run();
    }

    /**
     * Costruisce il distributore Split.
     */
    private static void build() {
        /** port to listen to producer */
        String ProducerPort = db.getPar("pp"); 
        IPipeIn in = new DriverIn(ProducerPort); 
        /** port to lowConsumer */
        String LowConsumerAddress = db.getPar("lca"); 
        String LowConsumerPort = db.getPar("lcp");
        IPipeOut outL = new DriverOut(LowConsumerAddress, LowConsumerPort); 
        /** up consumer address and port */
        String UpConsumerAddress = db.getPar("uca"); 
        String UpConsumerPort = db.getPar("ucp");
        IPipeOut outU = new DriverOut(UpConsumerAddress, UpConsumerPort); 
        
        logica = new Logica(in,outL,outU);
    }
}